; Omnicalc v1.10m (modified)
; (C) 2004 Eric Harmon
;
; Omnicalc v1.10
; (C) 2002-2003 Michael Vincent.
;
;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation; either version 2 of the License, or
;	(at your option) any later version.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

; Omnicalc v1.1
; Michael Vincent - michael@detachedsolutions.com
;
; Copyright (C) 2001-2003, by Michael Vincent. All rights reserved.
; Developed for Detached Solutions - www.detachedsolutions.com
; Project started 6-06-01.
; Rewrite started 12-21-01.
;
;
 NOLIST
 INCLUDE "ti83plus.inc"
 INCLUDE "michael.inc"
 LIST
 INCLUDE "equates.inc"
 GLOBALS ON
 INCLUDE "header.inc"
 	jp TotalAppStart
TotalAppStart:
	ld hl,Appvar
	rst 20h
	B_CALL ChkFindSym
	jr nc,StartApp
	ld hl,14
	B_CALL CreateAppVar
	ex de,hl
	inc hl
	inc hl
	ld b,14
CreateAppVar_Loop:
	ld (hl),0
	inc hl
	djnz CreateAppVar_Loop
	jr StartApp2
StartApp:
	ld a,b
	or a
	jr z,StartApp2
	B_CALL Arc_Unarc
StartApp2:
	ld hl,CatalogAppVar
	rst 20h
	B_CALL ChkFindSym
	jr nc,StartApp3
	ld hl,16
	B_CALL CreateAppVar
	ld b,16
	ex de,hl
	inc hl
	inc hl
StartApp_Clear:
	ld (hl),0
	inc hl
	djnz StartApp_Clear
StartApp3:
	call GetRealSettings
	bit 0,(hl)
	call nz,InstallHooks2
	B_CALL ClrLCDFull
	ld hl,Splash_Title
	ld de,9872h
	ld bc,400
	ldir
	ld hl,9872h
	ld de,1*256+7
	B_CALL DisplayImage
	ld hl,Splash_DS
	ld de,9872h
	ld bc,100
	ldir
	ld hl,9872h
	ld de,49*256+5
	B_CALL DisplayImage
	ld hl,57*256+9
	ld (pencol),hl
	ld hl,Intro_Web
	call vputstr
	ld hl,30*256+29
	ld (pencol),hl
	ld hl,Intro_Version
	call vputstr
	;ld hl,Splash_W
	;ld de,9872h
	;ld bc,3
	;ldir
	;ld hl,9872h
	;ld de,55*256+5
	;B_CALL DisplayImage
	xor a
	ld (counter),a
Splash_Loop1:
	ei
	halt
	halt
	B_CALL GetCSC
	or a
	jr nz,MainMenu
	ld a,(counter)
	inc a
	ld (counter),a
	jr nz,Splash_Loop1
	xor a
	ld (counter),a
	ld (counter2),a
Splash_Loop:
	ei
	halt
	B_CALL GetCSC
	or a
	jr nz,MainMenu
	ld a,(counter)
	add a,2
	ld (counter),a
	or a
	jr nz,Splash_Loop
	ld (counter),a
	ld hl,30*256
	ld de,37*256+95
	B_CALL ClearRect
	ld a,(counter2)
	ld b,a
	ld hl,Splash_Moving_Strings
	call getString
	ld a,30
	ld (penrow),a
	call Vputs_Centered
	ld a,(counter2)
	inc a
	ld (counter2),a
	cp 19
	jr nz,Splash_Loop
	ld b,200
	call Pause
MainMenu:
	call GetRealSettings
	bit 0,(hl)
	call nz,InstallHooks2
	B_CALL ClrScrnFull
	B_CALL GrBufClr
	ld hl,0
	ld de,7*256+95
	B_CALL FillRect
	set textInverse,(iy+textFlags)
	ld hl,30
	ld (pencol),hl
	ld hl,Title_MainMenu
	call vputstr
	res textInverse,(iy+textFlags)
	ld hl,Menu_Main
	call DisplayMenu
	ld hl,57*256
	ld (pencol),hl
	ld hl,MainScreenInstalled
	call vputstr
	call GetRealSettings
	ld a,(hl)
	ld hl,YesNo
	and 1
	add a,a
	add a,a
	ld d,0
	ld e,a
	add hl,de
	call vputstr
MainMenuLoop:
	B_CALL GetKey
	cp 3
	call z,MenuMoveUp
	cp 4
	call z,MenuMoveDown
	cp 5
	jr z,MainMenuSelected
	cp 9
	jr z,exitapp
	cp 40h
	jr z,exitapp
	cp 8Fh
	jp z,InstallRemove
	cp 90h
	jp z,Adjust
	cp 91h
	jp z,FontSets
	cp 92h
	jr nz,MainMenuLoop
exitapp:
	B_CALL SetTblGraphDraw
	B_JUMP JForceCmdNoChar
MainMenuSelected:
	ld a,(currentmenu)
	dec a
	jp z,InstallRemove
	dec a
	jp z,Adjust
	dec a
	jp z,FontSets
	dec a
	jr z,exitapp
InstallRemove:
	B_CALL GrBufClr
	B_CALL ClrScrnFull
	B_CALL GetBaseVer
	ld h,a
	ld l,b
	ld de,010Dh
	or a
	sbc hl,de
	jr c,OldBaseVersion
	call GetRealSettings
	bit 0,(hl)
	jp nz,Settings_Uninstall
	call DisplayMessageBox
	bit GetKeyHook,(iy+Hooks1)
	jp nz,Install_Hooks_Already
	bit TokenHook,(iy+Hooks2)
	jr nz,Install_Hooks_Already
	bit ParserHook,(iy+Hooks3)
	jr nz,Install_Hooks_Already
	bit cxMainHook,(iy+Hooks1)
	jr nz,Install_Hooks_Already
	bit GetcscHook,(iy+Hooks1)
	jr nz,Install_Hooks_Already
	bit FontHook,(iy+Hooks2)
	jr nz,Install_Hooks_Already
	;bit CharacterHook,(iy+Hooks2)
	;jr nz,Install_Hooks_Already
	ld hl,14*256+17
	ld (pencol),hl
	ld hl,Settings_Installed
	call vputstr
	ld de,30*256+27
	ld (pencol),de
	call vputstr
	call InstallHooks
	call GetRealSettings
	set 0,(hl)
	res onInterrupt,(iy+onFlags)
	B_CALL GetKey
	cp 40h
	jp z,exitapp
	jp MainMenu
OldBaseVersion:
	call DisplayMessageBox
	ld hl,14*256+17
	ld (pencol),hl
	ld hl,OldBaseVersion_Text
	call vputstr
	ld de,20*256+17
	ld (pencol),de
	call vputstr
	ld de,30*256+27
	ld (pencol),de
	call vputstr
	B_CALL GetKey
	jp exitapp
Install_Hooks_Already:
	call DrawYesNo
	ld hl,14*256+17
	ld (pencol),hl	
	ld hl,Settings_Already
	call vputstr
	ld de,21*256+17
	ld (pencol),de
	call vputstr
	ld de,57*256+4
	ld (pencol),de
	call vputstr
	ld a,25
	ld (pencol),a
	call vputstr
Settings_Overwriteloop:
	B_CALL GetKey
	cp 40h
	jp z,exitapp
	cp 48h
	jp z,MainMenu
	cp 49h
	jr nz,Settings_Overwriteloop
	call DisableHooks
	call GetRealSettings
	res 0,(hl)
	jp InstallRemove
DrawYesNo:
	ld bc,0
	ld de,5
	B_CALL DarkLine
	ld bc,19*256
	ld de,19*256+5
	B_CALL DarkLine
	ld bc,38*256
	ld de,38*256+5
	B_CALL DarkLine
	ld bc,2*256+7
	ld de,17*256+7
	B_CALL DarkLine
	ld bc,21*256+7
	ld de,36*256+7
	B_CALL DarkLine
	ld d,2
	ld bc,1*256+6
	B_CALL ipoint
	ld bc,18*256+6
	B_CALL ipoint
	ld bc,20*256+6
	B_CALL ipoint
	ld bc,37*256+6
	B_CALL ipoint
	ret
Settings_Uninstall:
	call DisableHooks
	call DisplayMessageBox
	call DrawYesNo
	ld hl,Uninstall_Prompt
	ld de,14*256+17
	ld (pencol),de
	call vputstr
	ld de,21*256+17
	ld (pencol),de
	call vputstr
	ld de,57*256+4
	ld (pencol),de
	call vputstr
	ld a,25
	ld (pencol),a
	call vputstr
Settings_Uninstall_YesNo:
	ei
	halt
	B_CALL GetCSC
	cp skWindow
	jp z,Settings_Uninstall_Done
	cp skYEqu
	jr nz,Settings_Uninstall_YesNo
	;Now begin the uninstall
	;Now check for wandering tokens
	;Search BASIC programs
	;String variables (answer variable included)
	;Equation variables
	;Past entries first
	ld a,(numLastEntries)
	ld b,a
	ld hl,lastEntryStk
Uninstall_Entries_Loop:
	push bc
	call Uninstall_ReplaceTokens
	pop bc
	djnz Uninstall_Entries_Loop
	;Now for programs
	ld hl,(progPtr)
Uninstall_BASIC_Loop:
	ld bc,(pTemp)
	or a
	sbc hl,bc
	jr z,Uninstall_BASIC_Done
	jr c,Uninstall_BASIC_Done
	add hl,bc
	ld a,(hl)
	and 1Fh
	cp 5
	jr nz,Uninstall_BASIC_NotProgram
	ld de,-5
	add hl,de
	;HL points to page byte
	ld a,(hl)
	or a
	jr nz,Uninstall_BASIC_NotProgramPage
	inc hl
	ld d,(hl)
	inc hl
	ld e,(hl)
	push hl
	ex de,hl
	;HL points to data start, size bytes
	call Uninstall_ReplaceTokens
	pop hl
	dec hl
	dec hl
Uninstall_BASIC_NotProgramPage:
	ld de,5
	add hl,de
Uninstall_BASIC_NotProgram:
	ld de,-6
	add hl,de
	ld d,0
	ld e,(hl)
	inc e
	or a
	sbc hl,de
	jr Uninstall_BASIC_Loop
Uninstall_BASIC_Done:
	;Now do equations and strings
	ld hl,symTable
Uninstall_Other_Loop:
	ld bc,(progPtr)
	or a
	sbc hl,bc
	jp c,Settings_Uninstall_Done
	jp z,Settings_Uninstall_Done
	add hl,bc
	ld a,(hl)
	and 1Fh
	cp StrngObj
	jr z,Uninstall_Other_Go
	cp EquObj
	jr z,Uninstall_Other_Go
	cp NewEquObj
	jr z,Uninstall_Other_Go
	ld de,-9
	add hl,de
	jr Uninstall_Other_Loop
Uninstall_Other_Go:
	dec hl
	dec hl
	dec hl
	ld e,(hl)
	dec hl
	ld d,(hl)
	ld bc,-5
	add hl,bc
	push hl
	ex de,hl
	call Uninstall_ReplaceTokens
	pop hl
	jr Uninstall_Other_Loop
Uninstall_ReplaceTokens:
	;Input:
	;HL - start of data, size bytes
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld a,b
	or c
	ret z
Uninstall_ReplaceTokens_Loop:
	ld a,0BBh
	cpir
	;Z if found, NZ otherwise
	ret nz
	;Found a match. HL points to the byte for the next cpir, BC is bytes remaining.
	ld a,b
	or c
	ret z
	;We are not at the end of the variable.
	ld a,(hl)
	cp 0CFh
	jr c,Uninstall_ReplaceTokens_LoopPrepare
	ld (hl),9Dh
Uninstall_ReplaceTokens_LoopPrepare:
	ld a,b
	or c
	ret z
	dec bc
	inc hl
	jr Uninstall_ReplaceTokens_Loop
Settings_Uninstall_Done:
	B_CALL ClrLCDFull
	call DisplayMessageBox
	ld hl,14*256+17
	ld (pencol),hl
	ld hl,Settings_Uninstalled
	call vputstr
	ld de,21*256+17
	ld (pencol),de
	call vputstr
	ld de,30*256+27
	ld (pencol),de
	call vputstr
	call GetRealSettings
	res 0,(hl)
	res onInterrupt,(iy+onFlags)
	B_CALL GetKey
	cp 40h
	jp z,exitapp
	jp MainMenu
Uninstall_Prompt:
	DB "Rename illegal",0
	DB "tokens?",0
	DB "YES",0
	DB "NO",0
Settings_Uninstalled:
	DB "Omnicalc",0
	DB "uninstalled",0
	DB "Press any key",0
Settings_Installed:
	DB "Omnicalc  installed",0
	DB "Press any key",0
Settings_Already:
	DB "Hooks already exist",0
	DB "Overwrite?",0
	DB "YES",0
	DB "NO",0
OldBaseVersion_Text:
	DB "ROM 1.13 or higher",0
	DB "is required.",0
	DB "Press any key",0
MainScreenInstalled:
	DB "Installed?",6,0
YesNo:
	DB "No",0,0
	DB "Yes",0
DisableHooks:
	res GetcscHook,(iy+Hooks1)		;RawKeyHook (_getkey)
	res TokenHook,(iy+Hooks2)		;Token hook
	res ParserHook,(iy+Hooks3)		;Parser hook
	res cxMainHook,(iy+Hooks1)		;cxMain hook
	res GetKeyHook,(iy+Hooks1)		;GetKeyHook (_getcsc)
	res FontHook,(iy+Hooks2)		;Font hook
	;res CharacterHook,(iy+Hooks2)	;Character hook
	ret
DisplayMessageBox:
	ld bc,16*256+50
	ld de,80*256+50
	B_CALL DarkLine
	ld bc,15*256+25
	ld de,81*256+25
	B_CALL DarkLine
	ld bc,16*256+24
	ld de,82*256+24
	B_CALL DarkLine
	ld de,81*256+49
	ld bc,81*256+25
	B_CALL DarkLine
	inc b
	inc d
	B_CALL DarkLine
	ld bc,15*256+49
	ld de,15*256+26
	B_CALL DarkLine
	ret
GetRealSettings:
	ld hl,Appvar
	rst 20h
	B_CALL ChkFindSym
	ld a,b
	or a
	jr nz,GetRealSettings_Archived
	jp c,GetRealSettings_NoExist
	ex de,hl
	inc hl
	inc hl
	ret
GetRealSettings_NoExist:
	ld hl,14
	B_CALL CreateAppVar
	ex de,hl
	inc hl
	inc hl
	ld b,14
GetRealSettings_NoExistLoop:
	ld (hl),0
	inc hl
	djnz GetRealSettings_NoExistLoop
	ret
GetRealSettings_Archived:
	B_CALL arc_unarc
	B_CALL ChkFindSym
	ex de,hl
	inc hl
	inc hl
	ret
InstallHooks:
	;set our non appvar byte
	xor a
	ld (rawKeyHookPtr+3),a
	;and our recursive parser thing
	ld (parserHookPtr+3),a
InstallHooks2:
	;First is _getkey hook.
	ld hl,Hook_Key
	in a,(6)
	B_CALL SetGetKeyHook
	;Token hook
	ld hl,Hook_Token
	in a,(6)
	B_CALL SetTokenHook
	;Parser hook
	ld hl,Hook_Parser
	in a,(6)
	B_CALL SetParserHook
	;Getcsc hook
	ld hl,csc_Hook
	in a,(6)
	B_CALL SetGetcscHook
	;cxMain hook
	ld hl,cxMain_Hook
	in a,(6)
	B_CALL SetcxMainHook
	;Character hook
	;ld hl,Character_Hook
	;in a,(6)
	;B_CALL SetCharacterHook
;InstallHooks_SkipcxMain:
	call GetRealSettings
	bit 7,(hl)
	jr z,InstallHooks_NoLower
	set lwrCaseActive,(iy+appLwrCaseFlag)
	jr InstallHooks_SkipLowercase
InstallHooks_NoLower:
	res lwrCaseActive,(iy+appLwrCaseFlag)
InstallHooks_SkipLowercase:
	inc hl
	inc hl
	ld (hl),10
	inc hl
	bit 0,(hl)
	ret z
	;Font hook
	ld hl,Font_Hook
	in a,(6)
	B_CALL SetFontHook
	ret
DisplayMenu:
	;Input - HL points to menu structure
	ld a,(hl)	;Get number of menus
	ld (menulimit),a
	ld b,a
	inc hl
	ld de,10*256
	ld (pencol),de
DisplayMenuLoop:
	push bc
	call vputstr
	xor a
	ld (pencol),a
	ld a,(penrow)
	add a,8
	ld (penrow),a
	pop bc
	djnz DisplayMenuLoop
	ld a,1
	ld (currentmenu),a
	jr MenuItemSet
MenuMoveDown:
	ld a,(menulimit)
	ld b,a
	ld a,(currentmenu)
	cp b
	ret z
	call MenuItemClear
	ld hl,currentmenu
	inc (hl)
	jr MenuItemSet
MenuMoveUp:
	ld a,(currentmenu)
	cp 1
	ret z
	call MenuItemClear
	ld hl,currentmenu
	dec (hl)
	jr MenuItemSet
MenuItemSet:
	;Input - (currentmenu) is current item
	set textInverse,(iy+textFlags)
	xor a
	ld (pencol),a
	ld a,(currentmenu)
	ld b,a
	ld a,2
MenuItemAddLoop:
	add a,8
	djnz MenuItemAddLoop
	ld (penrow),a
	ld a,(currentmenu)
	dec a
	ld b,a
	add a,a
	add a,b
	ld d,0
	ld e,a
	ld hl,Menu_Data
	add hl,de
	ld a,(hl)
	B_CALL VPutMap
	inc hl
	ld a,(hl)
	B_CALL VPutMap
	inc hl
	ld a,(hl)
	B_CALL VPutMap
	ld h,1
	call MenuUnderline
	res textInverse,(iy+textFlags)
	ret
MenuUnderline:
	ld a,(penrow)
	add a,6
	ld b,a
	ld a,63
	sub b
	ld c,a
	ld e,a
	ld b,0
	ld d,6
	B_CALL ILine
	ret
MenuItemClear:
	;Input - (currentmenu) is current item
	xor a
	ld (pencol),a
	ld a,(currentmenu)
	ld b,a
	ld a,2
MenuItemAddLoop2:
	add a,8
	djnz MenuItemAddLoop2
	ld (penrow),a
	ld a,(currentmenu)
	dec a
	ld b,a
	add a,a
	add a,b
	ld d,0
	ld e,a
	ld hl,Menu_Data
	add hl,de
	ld a,(hl)
	B_CALL vputmap
	inc hl
	ld a,(hl)
	B_CALL vputmap
	inc hl
	ld a,(hl)
	B_CALL vputmap
	ld h,0
	call MenuUnderline
	ret
Title_MainMenu:
	DB "MAIN  MENU",0
Menu_Main:
	DB 4
	DB " 1:   Install/Uninstall",0
	DB " 2:   General  Settings",0
	DB " 3:   Font  Sets",0
	DB " 4:   Quit",0
Intro_Web:
	DB "detachedsolutions.com",0
Appvar:
	DB AppVarObj,"Omnicalc"
CatalogAppVar:
	DB AppVarObj,"custom",0
;MirageOS:
;	DB AppVarObj,"MirageOS"
;MirageOSApp:
;	DB AppObj,"MirageOS"
Intro_Press:
	DB "PRESS ENTER",0
Menu_Data:
	DB " 1: 2: 3: 4: 5: 6: 7:"
Splash_Title:
	DB 21,81
	DB 0,0,0,0,0,0,0,0,6,0,0
	DB 0,0,0,0,0,0,0,0,14,0,0
	DB 0,0,0,0,0,0,0,0,14,0,0
	DB 7,224,0,0,0,0,0,0,6,0,0
	DB 31,240,0,0,0,3,0,0,6,0,0
	DB 60,120,0,0,0,3,0,0,6,0,0
	DB 112,28,0,0,0,0,0,0,6,0,0
	DB 96,28,64,0,24,7,0,31,6,0,0
	DB 192,12,254,124,59,135,7,223,134,15,128
	DB 192,12,255,254,63,199,31,193,134,63,128
	DB 192,12,227,142,56,231,56,1,134,48,0
	DB 192,12,195,6,48,230,48,1,198,96,0
	DB 192,28,195,6,48,102,32,15,198,96,0
	DB 192,24,195,6,48,102,32,29,134,96,0
	DB 224,56,195,14,48,198,48,49,134,96,0
	DB 240,112,195,12,48,199,56,51,142,112,0
	DB 127,224,195,28,48,199,31,255,142,63,128
	DB 31,128,195,28,49,199,15,221,206,31,128
	DB 0,0,0,28,1,192,0,1,192,0,0
	DB 0,0,0,0,0,0,0,1,128,0,0
	DB 0,0,0,0,0,0,0,0,0,0,0
Splash_DS:
	DB 5,86
	DB 231,188,199,107,220,28,204,107,222,103,28
	DB 214,25,172,107,26,49,172,105,140,214,176
	DB 215,25,236,123,154,25,172,105,140,214,152
	DB 214,25,172,107,26,13,172,105,140,214,140
	DB 231,153,167,107,220,56,207,49,158,102,184
;Splash_W:
;	DB 1,8
;	DB 10001000b
putstr:
	ld a,(hl)
	inc hl
	or a
	ret z
	B_CALL PutC
	jr putstr
vputstr:
	push af
	push de
	push ix
vputstr10:
	ld a,(hl)
	inc hl
	or a
	jr z,vputstr20
	B_CALL vputmap
	jr nc,vputstr10
vputstr20:
	pop ix
	pop de
	pop af
	ret
Pause:
	push af
Pause_Loop:
	B_CALL GetCSC
	ld (tempkey),a
	or a
	jr nz,Pause_Exit
	ei
	halt
	djnz Pause_Loop
Pause_Exit:
	pop af
	ret
getString:
	ld a,b
	or a
	ret z
getStringLoop:
	push bc
	xor a
	ld bc,-1
	cpir
	pop bc
	djnz getStringLoop
	ret
Vputs_Centered:
	ld c,0
	push hl
Vputs_Centered_Loop:
	push hl
	ld a,(hl)
	ld h,0
	ld l,a
	add hl,hl
	add hl,hl
	add hl,hl
	push bc
	B_CALL SFont_Len
	ld l,b
	pop bc
	ld a,c
	add a,l
	ld c,a
	pop hl
	inc hl
	ld a,(hl)
	or a
	jr nz,Vputs_Centered_Loop
	pop hl
	ld a,48
	sra c
	sub c
	ld (pencol),a
	ld de,(pencol)
	push de	;save cursor location
	push hl
	;HL now is start of string, and ready to display!
	call Display_EvenOffset_String
	ld b,35
	call Pause
	pop hl
	pop de
	ld (pencol),de
	push hl
	ld a,(hl)
	ld h,0
	ld l,a
	add hl,hl
	add hl,hl
	add hl,hl
	B_CALL SFont_Len
	ld a,(pencol)
	add a,b
	ld (pencol),a
	pop hl
	inc hl
Display_EvenOffset_String:
	ld a,(hl)
	or a
	ret z
	B_CALL VPutMap
	inc hl
	ld a,(hl)
	or a
	ret z
	push hl
	ld h,0
	ld l,a
	add hl,hl
	add hl,hl
	add hl,hl
	B_CALL SFont_Len
	ld a,(pencol)
	add a,b
	ld (pencol),a
	pop hl
	inc hl
	jr Display_EvenOffset_String
Splash_Moving_Strings:
	;19 strings
	DB "Programmed  By:",0
	DB "Michael  Vincent",0
	DB "E-mail:",0
	DB "me@michaelv.org",0
	DB "  ",0
	DB "Clipboard Version By:",0
	DB "Eric Harmon",0
	DB "E-mail:",0
	DB "shard@nerisoft.com",0
	DB " ",0
	DB "Special  Thanks:",0
	DB "Brandon  Sterner",0
	DB "Dan  Englender",0
	DB "Jason  Kovacs",0
	DB "Kirk  Meyer",0
	DB "Brandon  Wilson",0
	DB "  ",0
	DB "  ",0
	DB "The Beta Testing Team",0
	INCLUDE "settings.asm"
	INCLUDE "hooks.asm"
Intro_Version:
	DB "Version 1.10m",0
CompareStrings:
	;HL, DE strings for B bytes
	;There is an undocumented B_CALL but this is ~2000 cycles faster
	ld a,(de)
	cp (hl)
	ret nz
	inc hl
	inc de
	djnz CompareStrings
	xor a
	ret
lcd_delay:
	push af
	call LCD_BUSY_QUICK
	pop af
	ret
