; Omnicalc v1.10
; (C) 2002-2003 Michael Vincent.
;
;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation; either version 2 of the License, or
;	(at your option) any later version.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
Hook_Token:
	add a,e
	push hl
	push de
	ld hl,3F6h
	or a
	sbc hl,de
	jr z,Hook_Token_Real
	pop hl
	ld	de,0548h
	or	a
	sbc hl,de
	ex	de,hl
	pop hl
	ret c
	rr	e
	ld	a,e
	jr	Hook_Token_Get
Hook_Token_Real:
	pop de
	pop hl
	ld a,(tokenHookPtr+3)
	cp 2
	jr z,Hook_Token_RealGO
	scf
	ret
Hook_Token_RealGO:
	ld a,(rawkeyhookptr+3)
	ld b,a
	sub 0CFh
	ret c
	ld hl,(editCursor)
	dec hl
	ld (hl),b
Hook_Token_Get:
	sla a
	ld	e,a
	ld	d,0
	ld	hl,Hook_Token_Table
	add hl,de
	ld	e,(hl)
	inc hl
	ld	d,(hl)
	ex	de,hl
	inc hl
	ld	b,0
	ld	c,(hl)
	dec hl
	inc bc
	inc bc
	inc bc
	ld	de,localtokstr
	ldir
	xor a
	ld	(rawkeyhookptr+3),a
	ld	hl,localtokstr
	ret
Hook_Token_Table:
	DW Hook_Token_Symbolic_csc
	DW Hook_Token_Symbolic_csc1
	DW Hook_Token_Symbolic_sec
	DW Hook_Token_Symbolic_sec1
	DW Hook_Token_Symbolic_cot
	DW Hook_Token_Symbolic_cot1
	DW Hook_Token_Symbolic_csch
	DW Hook_Token_Symbolic_csch1
	DW Hook_Token_Symbolic_sech
	DW Hook_Token_Symbolic_sech1
	DW Hook_Token_Symbolic_coth
	DW Hook_Token_Symbolic_coth1
	DW Hook_Token_Symbolic_d
	DW Hook_Token_Symbolic_simp
	DW Hook_Token_Symbolic_sign
	DW Hook_Token_Symbolic_version
	DW Hook_Token_Symbolic_arclength
	DW Hook_Token_Symbolic_let
	DW Hook_Token_Symbolic_numstr
	DW Hook_Token_Symbolic_pretty
	DW Hook_Token_SpriteToken
	DW Hook_Token_RomanToken
	DW Hook_Token_RootToken
	DW Hook_Token_FactorToken
	DW Hook_Token_GammaToken
	DW Hook_Token_BaseToken
	DW Hook_Token_LinkGetToken
	DW Hook_Token_LinkSendToken
	DW Hook_Token_ModuloToken
	DW Hook_Token_ConstantToken
	DW Hook_Token_SubfactorialToken
	DW Hook_Token_ProgramToken
	DW Hook_Token_RestoreMemoryToken
Hook_Token_Symbolic_csc:
	DB 0,4,"csc(",0
Hook_Token_Symbolic_csc1:
	DB 0,5,"csc",linverse,"(",0
Hook_Token_Symbolic_sec:
	DB 0,4,"sec(",0
Hook_Token_Symbolic_sec1:
	DB 0,5,"sec",linverse,"(",0
Hook_Token_Symbolic_cot:
	DB 0,4,"cot(",0
Hook_Token_Symbolic_cot1:
	DB 0,5,"cot",linverse,"(",0
Hook_Token_Symbolic_csch:
	DB 0,5,"csch(",0
Hook_Token_Symbolic_csch1:
	DB 0,6,"csch",linverse,"(",0
Hook_Token_Symbolic_sech:
	DB 0,5,"sech(",0
Hook_Token_Symbolic_sech1:
	DB 0,6,"sech",linverse,"(",0
Hook_Token_Symbolic_coth:
	DB 0,5,"coth(",0
Hook_Token_Symbolic_coth1:
	DB 0,6,"coth",linverse,"(",0
Hook_Token_Symbolic_d:
	DB 0,2,"d(",0
Hook_Token_Symbolic_simp:
	DB 0,5,"simp(",0
Hook_Token_Symbolic_sign:
	DB 0,5,"sign(",0
Hook_Token_Symbolic_version:
	DB 0,8,"version(",0
Hook_Token_Symbolic_arclength:
	DB 0,10,"arclength(",0
Hook_Token_Symbolic_let:
	DB 0,4,"let(",0
Hook_Token_Symbolic_numstr:
	DB 0,7,"numStr(",0
Hook_Token_Symbolic_pretty:
	DB 0,7,"pretty(",0
Hook_Token_SpriteToken:
	DB 0,7,"sprite(",0
Hook_Token_RomanToken:
	DB 0,8,"Rom",5,"Dec(",0
Hook_Token_RootToken:
	DB 0,6,"simp",10h,"(",0
Hook_Token_FactorToken:
	DB 0,7,"factor(",0
Hook_Token_GammaToken:
	DB 0,6,"gamma(",0
Hook_Token_BaseToken:
	DB 0,10,"baseInput(",0
Hook_Token_LinkGetToken:
	DB 0,8,"linkGet(",0
Hook_Token_LinkSendToken:
	DB 0,9,"linkSend(",0
Hook_Token_ModuloToken:
	DB 0,4,"mod(",0
Hook_Token_ConstantToken:
	DB 0,6,"const(",0
Hook_Token_SubfactorialToken:
	DB 0,3,"!n(",0
Hook_Token_ProgramToken:
	DB 0,8,"program(",0
Hook_Token_RestoreMemoryToken:
	DB 0,11,"RestoreMem(",0
